#!/bin/sh
# $Id: t-log-0.sh,v 1.26 2014/01/15 04:26:20 ca Exp $
#
test -s stop && exit 1
# 

if test X"${MTA_NO_LOG_TEST}" != "X"
then
  exit 0
fi

P=./t-logentry-0

ERRS=0
OUT=log.out
ERR=log.err
OKERR=ok.err
OKOUT=ok.out
rm -f ${OUT} ${ERR} ${OKOUT} ${OKERR}

$P  | sed -e 's/^\[[0-9/:-]*\] //' > ${OUT} 2> ${ERR}
cat > ${OKOUT} <<EOF
func=function, where=here, name=value
name1=value1, name2=value2, name3=value3
ta_id=S000000000010830600, msgid=<a%09=c=,b@example.tld>, status=Sent
ta_id=S001000000010830600, stat=250
stat=471
se_id=S00A000010010830600, stat=0x1f, stat=4RV, stat=3uIjwl, ptr=0xdeac137f
se_id=S11A111111111830610, stat=37, stat=11577, stat=F84ADEAF
se_id=S00A0B0010010830F00, status=1234567890abcdefghijklmnopqrstuvwxyz, prec=123456
se_id=S00A0B00CD0E0830F01, cstr=ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890, width=     6
da_se=CF0A0B00CD0E0830F01, string=ab%25, nrcpts=5
xtext=a+20b+2Bc+2Cd+09e, fp8=1A:8F:E1:D7, fp16=1A8F:E1D7
fp8=0A:8F:0E
Thash=0, stat=0x80000001, ipv4=127.0.0.1
newname=newvalue
func=function1, where=here1, name=value1
long=87654321, short=8fad, char=7e
ip=12.234.99.39
io=File exists, module=IO, IBDB=File exists, module=IO
status=File exists, stat=421
ta_id=S000000000010830600, status=Sent, str=flushed
ta_id=S001000000010830600, idx=0, idx=1, idx=2, idx=3, idx=4, idx=5, idx=6, idx=7, string=Flushed
EOF

if $P -C | grep MTA_NETINET6 >/dev/null
then
cat >> ${OKOUT} <<EOF
ipv6=fe80:0:0:0:2a0:c9ff:fee6:826b
ipv6=0:0:0:0:0:0:0:1
EOF
fi

diff ${OUT} ${OKOUT} || ERRS=`expr ${ERRS} + 1 `

test ${ERRS} -eq 0 && rm -f ${OUT} ${ERR} ${OKOUT} ${OKERR}

exit ${ERRS}
