/*
 *	$Id: tlsdane.h,v 1.3 2013/12/28 21:08:05 ca Exp $
 */

#ifndef SM_TLSDANE_H
#define SM_TLSDANE_H 1
#if MTA_USE_TLS
#include "sm/generic.h"
#include "sm/str.h"
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/bio.h>
#include <openssl/pem.h>
#include <openssl/x509.h>
#include <openssl/x509v3.h>

/* RFC 6698 */
/* Section 7.2 */
#define DNS_TLSA_USAGE_CA_CONSTRAINT			0
#define DNS_TLSA_USAGE_SERVICE_CERTIFICATE_CONSTRAINT	1
#define DNS_TLSA_USAGE_TRUST_ANCHOR_ASSERTION		2
#define DNS_TLSA_USAGE_DOMAIN_ISSUED_CERTIFICATE	3

/* Section 7.3 */
#define DNS_TLSA_SELECTOR_FULL_CERTIFICATE	0
#define DNS_TLSA_SELECTOR_SUBJECTPUBLICKEYINFO	1

/* Section 7.4 */
#define DNS_TLSA_MATCHING_TYPE_NO_HASH_USED	0
#define DNS_TLSA_MATCHING_TYPE_SHA256		1
#define DNS_TLSA_MATCHING_TYPE_SHA512		2

# if MTA_TLS_DANE
struct dane_ctx_S
{
    uint8_t			 dc_id;
};
typedef struct dane_ctx_S dane_ctx_T, *dane_ctx_P;

sm_ret_T dane_init(dane_ctx_P *_dane_ctx);
# endif /* MTA_TLS_DANE */

#endif /* MTA_USE_TLS */

#endif /* SM_TLSDANE_H */
