#!/bin/sh
# $Id: t-conf-union-choice-1.sh,v 1.2 2010/10/24 18:49:33 ca Exp $
#

test -s stop && exit 1

# source directory of this (and other) shell script
SD=`dirname $0`

ERRS=0

CNF=smc1.conf
OUT=smc1.out
OK=smc1.ok

PRG=./t-conf-union-choice-1

rm -f ${CNF} ${OUT} ${OK}

check() {
if ${PRG} ${CNF} >${OUT} 2>&1
then
  if diff ${OK} ${OUT}
  then
    :
  else
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  ERRS=`expr ${ERRS} + 1 `
fi
}

# ----------------
TEST=1
cat > ${CNF} <<EOF
VERP { add = jobid; }
EOF
cat > ${OK} <<EOF
VERP {
  # when to use VERP
  when=  when_requested;
  # add something else to sender address
  add=  # add jobid (not yet available)
  jobid;
}
EOF
check

# ----------------
TEST=2
cp ${OK} ${CNF}
check

# ----------------
TEST=3
cat > ${CNF} <<EOF
VERP { when = never; }
EOF
cat > ${OK} <<EOF
VERP {
  # when to use VERP
  when=  # never use VERP
  never;
  # add something else to sender address
  add=  nothing;
}
EOF
check

# ----------------
TEST=4
cp ${OK} ${CNF}
check

# ----------------
if test ${ERRS} -eq 0
then
  rm -f ${CNF} ${OUT} ${OK}
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
