#!/bin/sh
# $Id: t-expr-2.sh,v 1.1 2010/06/10 03:46:27 ca Exp $
#

test -s stop && exit 1

# source directory of this (and other) shell script
SD=`dirname $0`

ERRS=0
OUT=ex2.out
ERR=ex2.err
OK=ex2.ok
PRG=./t-expr-0

TEST=0
# 'expr == mail=~"example\.com>$" && rcpt =~ "example\.net";'
for i in 'mail=~"example\.com":1' 'mail=~"example\.com>$":1' 'mail=~"example\.com>$" && rcpt =~ "example\.net":1'
do
  TEST=`expr $TEST + 1 `
  E=`echo $i | cut -d: -f1`
  R=`echo $i | cut -d: -f2`
  echo "expr == $E;" | $PRG 2>$ERR | grep 'expr:' > $OUT
  printf "expr: %d\n" $R > $OK
  if diff $OUT $OK
  then
    :
  else
    echo "$0: test ${TEST} failed: expr=$E, expected=$R"
    ERRS=`expr ${ERRS} + 1 `
  fi
done

# ----------------
if test "${ERRS}" = "0"
then
  rm -f ${OUT} ${OK} ${ERR}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
