/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-log-2.c,v 1.2 2014/04/18 01:17:18 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/test.h"
#include "sm/ctype.h"
#include "sm/io.h"
#include "sm/log.h"

static int Verbosity = 0;

static sm_ret_T
test(long maxl)
{
	sm_ret_T ret;
	const char *uts;
	char *sec, old;
	long l;
	long off;

	ret = SM_SUCCESS;

	uts = sm_log_utstamp();
	SM_TEST_E(uts != NULL);
	sec = strrchr(uts, '.');
	SM_TEST_E(sec != NULL);
	SM_TEST_E(sec > uts);
	--sec;
	SM_TEST_E(sec >= uts);
	old = *sec;
	SM_TEST_E(ISDIGIT(old));
	off = sec - uts;
	SM_TEST_E(off > 0);
	SM_TEST_E(off < strlen(uts));
	for (l = 0; l < maxl; l++) {
		uts = sm_log_utstamp();
		SM_TEST_E(uts != NULL);
		if (Verbosity > 1)
			sm_io_fprintf(smioerr, "%s\n", uts);
		if (old != uts[off]) {
			sm_io_fprintf(smioerr, "l=%ld, sec=%c, new=%c\n", l, old, uts[off]);
			break;
		}
	}
	SM_TEST_E(l < maxl);
	return ret;

  error:
	return ret;
}

int
main(int argc, char *argv[])
{
	int c;
	long maxl;

	maxl = 9000000;
	while ((c = getopt(argc, argv, "l:V")) != -1) {
		switch (c) {
		  case 'l':
			maxl = strtol(optarg, NULL, 0);
			break;
		  case 'V':
			++Verbosity;
			break;
		}
	}
	sm_test_begin(argc, argv, "test utstamp");
	argc -= optind;
	argv += optind;
	test(maxl);
	return sm_test_end();
}
