#!/bin/sh
# $Id: smtpa.sh,v 1.2 2010/10/03 17:21:31 ca Exp $
#
# running SMTP server with 'accept everything'

# host on which to listen/to which to send
H=localhost
# port number to use
P=${MTA_SRVPORT:-1235}
ERRS=0
SRVL="smtps.log"
CLTL="smtpc.log"
rm -f $SRVL $CLTL
#

SRV=smtps2
# start SMTP server
./$SRV -/ -b $H:$P > $SRVL 2>&1 &
status=$?
SRVPID=$!
if [ "x$status" != "x0" ]
then
  echo "FAIL: cannot start server $status"
  exit $status
fi
sleep 3
if grep "ERROR" $SRVL > /dev/null
then
  echo "found ERROR in $SRVL"
  ERRS=`expr $ERRS + 1 `
fi

for f in s451@meta1.org s551@meta1.org r451@meta1.org r551@meta1.org
do
  case "$f" in
    s*) O="-f";;
    r*) O="-R";;
  esac
if ./smtpc2 -d 4 $O"$f" -r $H:$P > $CLTL 2>&1
then
  if grep $f $CLTL >/dev/null
  then
    :
  else
     ERRS=`expr $ERRS + 1 `
  fi
  if grep DATA $CLTL >/dev/null
  then
    :
  else
     ERRS=`expr $ERRS + 1 `
  fi
else
  cat $CLTL
  ERRS=`expr $ERRS + 1 `
fi
done

# stop server
kill ${SRVPID}

if [ $ERRS -gt 0 ]
then
	echo "$ERRS error(s)"
	exit 1
fi

#rm -f $SRVL $CLTL
exit 0
